#include "m.h"


char *shortname = "HERouter";
char *ver = "0.00.00";
char *MYOS = "OpenBSD 3.1";
short verhi = 0;
short verlo = 0;

struct stat sb[1];
Tcl_Interp *interp;
int err;
DIR *netmaildir;
char *NETMAIL;         // Netmail dir; read from config
struct dirent *direent;
ClientData cd;
// The name of Current Message for Ftn_Store, Ftn_Delete, etc.
char messname[PATH_MAX];

main(int args,char **argv)
{
 char *routescript;

 if (args != 2)
 {
  printf("HERouter (XEPb.ru/dtz)\nUsage: %s configfile\n",argv[0]);
  exit(1);
 }

 printf("+Starting %s %s\n",shortname,ver); 
 srand((unsigned int) time(0));

// Loading Config file
 if(stat(argv[1],sb)) 
 {
  printf("!Unable to stat() config file %s\n",argv[1]);
  exit(254);
 }
 interp = Tcl_CreateInterp();
 CreateCommands();

 if (TCL_OK != (Tcl_EvalFile(interp,argv[1])))
 {
  printf("!Unable to load %s: %s",argv[1],Tcl_ErrnoMsg(Tcl_GetErrno()));
  exit(254);
 }
// Ok, config is loaded
// Let's open Netmaildir!
 if (!(NETMAIL = Tcl_GetVar(interp,"Netmail",0))) 
 {
  printf("!Config error: 'Netmail' is not defined\n");
  exit(252);
 }
 if (!(routescript = Tcl_GetVar(interp,"RouteScript",0))) 
 {
  printf("!Config error: 'RouteScript' is not defined\n");
  exit(252);
 }
 if (NULL == Tcl_GetVar(interp,"Outbound",0)) {
  printf("!Config error: 'Outbound' is not defined\n");
  exit(252); 
 }

// printf("Netmail is defined as %s\n",NETMAIL);
 if (NULL == (netmaildir = opendir(NETMAIL)) )
 {
  perror("Cannot open Netmail");
  exit(253);
 }
 while (NULL != (direent = readdir(netmaildir))) {
//  printf(".");
//  printf("Got file %s\n",direent->d_name);
  if (!strncmp(".msg",direent->d_name + strlen(direent->d_name) - 4,4))
  {
   sprintf(messname,"%s/%s",NETMAIL,direent->d_name);
   printf("+Scanning %s\r",messname);
   if (readmsg(messname)) 
   {
    printf("!Cant readmsg %s - skipping it\n",direent->d_name);
   }
   else 
   {
    if (TCL_OK != (Tcl_EvalFile(interp,routescript))) 
    {
     printf("!Got error executing %s: %s\n",routescript,Tcl_ErrnoMsg(Tcl_GetErrno()));
    }
   }
  }
 }
 closedir(netmaildir);

}
